<?php
/*
Plugin Name: Facebook Tab Manager
Plugin URI: http://www.carrcommunications.com/wordpress-plugins/facebook-tab-manager/
Description: Makes WordPress function as an editor for tabs you can embed in a Facebook page for your business, campaign, or organization. Include any WordPress content, including output from Shortcodes and other plugin functions.
Author: David F. Carr
Version: 1.1
Author URI: http://www.carrcommunications.com/
*/

//make sure new rules will be generated for custom post type

function draw_taboptions() {

global $post;

if($_GET["post"])
{
$custom_fields = get_post_custom($post->ID);
$permalink = get_permalink($post->ID);
}
?>
CSS Styles:<br /> 
<textarea name="fbtabset[style]" cols="60" rows="5"><?=$custom_fields["_style"][0]?></textarea><br />
<a target="_blank" href="<?=plugins_url()?>/facebook-tab-manager/fbtab-css.php?show=text">See default styles</a><br />
<input type="checkbox" name="fbtabset[new_window]" value="1" <?php if($custom_fields["_new_window"][0]) echo ' checked="checked" '; ?>  />
Open Links / Post Forms to New Window<br />
<input type="checkbox" name="fbtabset[wp_head]" value="1" <?php if($custom_fields["_wp_head"][0]) echo ' checked="checked" '; ?>  />
Template should execute theme/plugin code in HTML head - wp_head() command<br />
<input type="checkbox" name="fbtabset[wp_footer]" value="1" <?php if($custom_fields["_wp_footer"][0]) echo ' checked="checked" '; ?>  />
Template should execute theme/plugin code in page footer - wp_footer()<br />

<input type="hidden" name="fbtabdata" value="1"  />
<?php

if($permalink)
	{
	$pp = explode('/fbtab/',$permalink);
	//print_r($pp);
	$bp = explode('//',$pp[0]);
	//print_r($bp);
?>
<h3>To Install This as a Facebook Tab</h3>
<ol>
  <li>Visit the <a href="http://www.facebook.com/developers/" target="_blank">Facebook Developers</a> utility for app registration</li>
  <li>Click the Create New App button</li>
  <li>Fill out the registraition form, including the parameters below</li>
</ol>
<p><strong>Website Tab</strong>
  <br />
  Site URL: <?=$permalink?><br />
Site Domain: <?=$bp[1]?></p>

<p><strong>Facebook Integration Tab</strong>
  <br />
  Canvas URL: <?=$pp[0]?>/fbtab/<br />
Tab Name: <?=$post->post_title?><br />
Tab URL: [CANVAS URL]/<?=$pp[1]?> (Enter &quot;<?=$pp[1]?>&quot; in the blank)</p>
<p>Example Configuration:<br />
  <br />
  <img src="<?=plugins_url()?>/fbtab/screenshot-1.png" alt="Example Configuration" width="516" height="691" /><br />
</p>
<?php
	}

}

add_action( 'init', 'create_fbtab_post_type' );

//    'menu_icon' => WP_PLUGIN_URL.'/chimpblast/email.gif',

function create_fbtab_post_type() {
  register_post_type( 'fbtab',
    array(
      'labels' => array(
        'name' => __( 'Facebook Tabs' ),
        'add_new_item' => __( 'Add New Facebook Tab' ),
        'edit_item' => __( 'Edit Facebook Tab' ),
        'new_item' => __( 'Facebook Tabs' ),
        'singular_name' => __( 'Facebook Tab' )
      ),
	'public' => true,
	'exclude_from_search' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'query_var' => true,
    'rewrite' => true,
    'capability_type' => 'page',
    'hierarchical' => false,
    'menu_position' => 5,
	'menu_icon' => WP_PLUGIN_URL.'/chimpblast/email.gif',
    'supports' => array('title','editor')
    )
  );
}

add_action("template_redirect", 'fbtab_template_redirect');

// Template selection
function fbtab_template_redirect()
{

global $wp;
global $wp_query;

	if ($wp->query_vars["post_type"] == "fbtab")
	{
		if (have_posts())
		{
			include(WP_PLUGIN_DIR . '/fbtab/template.php');
			die();
		}
		else
		{
			$wp_query->is_404 = true;
		}

	}
}

function my_fbtab_menu() {
add_meta_box( 'fbtabbox', 'Options', 'draw_taboptions', 'fbtab', 'normal', 'high' );
}

add_action('admin_menu', 'my_fbtab_menu');

function save_fbtab_data($postID) {

if(!$_POST["fbtabdata"])
	return;
// we only care about saving fbtabdata

	global $wpdb;
	global $current_user;
	
	if($parent_id = wp_is_post_revision($postID))
		{
		$postID = $parent_id;
		}
		
		foreach($_POST["fbtabset"] as $name => $value)
			{
			$field = '_'.$name;
			$single = true;
			$current = get_post_meta($postID, $field, $single);
			 
			if($value && ($current == "") )
				add_post_meta($postID, $field, $value, true);
			
			elseif($value != $current)
				update_post_meta($postID, $field, $value);
			
			elseif($value == "")
				delete_post_meta($postID, $field, $current);
			}
	
}

add_action('save_post','save_fbtab_data');

add_filter('mce_css', 'fbtab_mce_css');
function fbtab_mce_css($style) {
global $post;
if(($post->post_type == 'fbtab') || ($_GET["post_type"] == 'fbtab'))
  return plugins_url().'/facebook-tab-manager/fbtab-css.php?postid='.$post->ID;
}

?>